<?php
/**
 * InlineResponse20040ContentItemsAllOfHistoryInner
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20040ContentItemsAllOfHistoryInner Class Doc Comment
 *
 * @category Class
 * @description Describes a change in a timestamp object
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20040ContentItemsAllOfHistoryInner implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_40_contentItems_allOf_history_inner';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'timestampId' => 'int',
        'date' => 'int',
        'changeByUserId' => 'int',
        'fromState' => 'string',
        'fromType' => 'string',
        'fromDate' => 'int',
        'toState' => 'object',
        'toType' => 'object',
        'toDate' => 'int',
        'historyType' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'timestampId' => null,
        'date' => 'timestamp',
        'changeByUserId' => null,
        'fromState' => null,
        'fromType' => null,
        'fromDate' => 'timestamp',
        'toState' => null,
        'toType' => null,
        'toDate' => 'timestamp',
        'historyType' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'timestampId' => 'timestampId',
        'date' => 'date',
        'changeByUserId' => 'changeByUserId',
        'fromState' => 'fromState',
        'fromType' => 'fromType',
        'fromDate' => 'fromDate',
        'toState' => 'toState',
        'toType' => 'toType',
        'toDate' => 'toDate',
        'historyType' => 'historyType'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'timestampId' => 'setTimestampId',
        'date' => 'setDate',
        'changeByUserId' => 'setChangeByUserId',
        'fromState' => 'setFromState',
        'fromType' => 'setFromType',
        'fromDate' => 'setFromDate',
        'toState' => 'setToState',
        'toType' => 'setToType',
        'toDate' => 'setToDate',
        'historyType' => 'setHistoryType'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'timestampId' => 'getTimestampId',
        'date' => 'getDate',
        'changeByUserId' => 'getChangeByUserId',
        'fromState' => 'getFromState',
        'fromType' => 'getFromType',
        'fromDate' => 'getFromDate',
        'toState' => 'getToState',
        'toType' => 'getToType',
        'toDate' => 'getToDate',
        'historyType' => 'getHistoryType'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const FROM_STATE_TRUE = 'true';
    public const FROM_STATE_FALSE = 'false';
    public const FROM_STATE_PAUSE_START = 'PAUSE_START';
    public const FROM_STATE_PAUSE_END = 'PAUSE_END';
    public const FROM_TYPE_WORK = 'WORK';
    public const FROM_TYPE_INHOUSE = 'INHOUSE';
    public const FROM_TYPE_ERRAND = 'ERRAND';
    public const FROM_TYPE_VACATION = 'VACATION';
    public const FROM_TYPE_ILLNESS = 'ILLNESS';
    public const FROM_TYPE_ABSENCE_PAID = 'ABSENCE_PAID';
    public const FROM_TYPE_ABSENCE_UNPAID = 'ABSENCE_UNPAID';
    public const FROM_TYPE_OVERTIME = 'OVERTIME';
    public const FROM_TYPE_DOCUMENTED_SUPPORT = 'DOCUMENTED_SUPPORT';
    public const HISTORY_TYPE_CREATED = 'CREATED';
    public const HISTORY_TYPE_UPDATED = 'UPDATED';
    public const HISTORY_TYPE_DELETED = 'DELETED';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getFromStateAllowableValues()
    {
        return [
            self::FROM_STATE_TRUE,
            self::FROM_STATE_FALSE,
            self::FROM_STATE_PAUSE_START,
            self::FROM_STATE_PAUSE_END,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getFromTypeAllowableValues()
    {
        return [
            self::FROM_TYPE_WORK,
            self::FROM_TYPE_INHOUSE,
            self::FROM_TYPE_ERRAND,
            self::FROM_TYPE_VACATION,
            self::FROM_TYPE_ILLNESS,
            self::FROM_TYPE_ABSENCE_PAID,
            self::FROM_TYPE_ABSENCE_UNPAID,
            self::FROM_TYPE_OVERTIME,
            self::FROM_TYPE_DOCUMENTED_SUPPORT,
        ];
    }

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getHistoryTypeAllowableValues()
    {
        return [
            self::HISTORY_TYPE_CREATED,
            self::HISTORY_TYPE_UPDATED,
            self::HISTORY_TYPE_DELETED,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['timestampId'] = $data['timestampId'] ?? null;
        $this->container['date'] = $data['date'] ?? null;
        $this->container['changeByUserId'] = $data['changeByUserId'] ?? null;
        $this->container['fromState'] = $data['fromState'] ?? null;
        $this->container['fromType'] = $data['fromType'] ?? null;
        $this->container['fromDate'] = $data['fromDate'] ?? null;
        $this->container['toState'] = $data['toState'] ?? null;
        $this->container['toType'] = $data['toType'] ?? null;
        $this->container['toDate'] = $data['toDate'] ?? null;
        $this->container['historyType'] = $data['historyType'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getFromStateAllowableValues();
        if (!is_null($this->container['fromState']) && !in_array($this->container['fromState'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'fromState', must be one of '%s'",
                $this->container['fromState'],
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getFromTypeAllowableValues();
        if (!is_null($this->container['fromType']) && !in_array($this->container['fromType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'fromType', must be one of '%s'",
                $this->container['fromType'],
                implode("', '", $allowedValues)
            );
        }

        $allowedValues = $this->getHistoryTypeAllowableValues();
        if (!is_null($this->container['historyType']) && !in_array($this->container['historyType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'historyType', must be one of '%s'",
                $this->container['historyType'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id of the history log entry
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets timestampId
     *
     * @return int|null
     */
    public function getTimestampId()
    {
        return $this->container['timestampId'];
    }

    /**
     * Sets timestampId
     *
     * @param int|null $timestampId id of the timestamp which this history entry is for
     *
     * @return self
     */
    public function setTimestampId($timestampId)
    {
        $this->container['timestampId'] = $timestampId;

        return $this;
    }

    /**
     * Gets date
     *
     * @return int|null
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param int|null $date timestamp when the change occured
     *
     * @return self
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets changeByUserId
     *
     * @return int|null
     */
    public function getChangeByUserId()
    {
        return $this->container['changeByUserId'];
    }

    /**
     * Sets changeByUserId
     *
     * @param int|null $changeByUserId id of the user which did this change
     *
     * @return self
     */
    public function setChangeByUserId($changeByUserId)
    {
        $this->container['changeByUserId'] = $changeByUserId;

        return $this;
    }

    /**
     * Gets fromState
     *
     * @return string|null
     */
    public function getFromState()
    {
        return $this->container['fromState'];
    }

    /**
     * Sets fromState
     *
     * @param string|null $fromState Determines the state for the timestamp (i.e. on, off)
     *
     * @return self
     */
    public function setFromState($fromState)
    {
        $allowedValues = $this->getFromStateAllowableValues();
        if (!is_null($fromState) && !in_array($fromState, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'fromState', must be one of '%s'",
                    $fromState,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['fromState'] = $fromState;

        return $this;
    }

    /**
     * Gets fromType
     *
     * @return string|null
     */
    public function getFromType()
    {
        return $this->container['fromType'];
    }

    /**
     * Sets fromType
     *
     * @param string|null $fromType Determines the type for the timestamp (i.e. work)
     *
     * @return self
     */
    public function setFromType($fromType)
    {
        $allowedValues = $this->getFromTypeAllowableValues();
        if (!is_null($fromType) && !in_array($fromType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'fromType', must be one of '%s'",
                    $fromType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['fromType'] = $fromType;

        return $this;
    }

    /**
     * Gets fromDate
     *
     * @return int|null
     */
    public function getFromDate()
    {
        return $this->container['fromDate'];
    }

    /**
     * Sets fromDate
     *
     * @param int|null $fromDate fromDate
     *
     * @return self
     */
    public function setFromDate($fromDate)
    {
        $this->container['fromDate'] = $fromDate;

        return $this;
    }

    /**
     * Gets toState
     *
     * @return object|null
     */
    public function getToState()
    {
        return $this->container['toState'];
    }

    /**
     * Sets toState
     *
     * @param object|null $toState toState
     *
     * @return self
     */
    public function setToState($toState)
    {
        $this->container['toState'] = $toState;

        return $this;
    }

    /**
     * Gets toType
     *
     * @return object|null
     */
    public function getToType()
    {
        return $this->container['toType'];
    }

    /**
     * Sets toType
     *
     * @param object|null $toType toType
     *
     * @return self
     */
    public function setToType($toType)
    {
        $this->container['toType'] = $toType;

        return $this;
    }

    /**
     * Gets toDate
     *
     * @return int|null
     */
    public function getToDate()
    {
        return $this->container['toDate'];
    }

    /**
     * Sets toDate
     *
     * @param int|null $toDate new timestamp (is 0 if the entry was deleted)
     *
     * @return self
     */
    public function setToDate($toDate)
    {
        $this->container['toDate'] = $toDate;

        return $this;
    }

    /**
     * Gets historyType
     *
     * @return string|null
     */
    public function getHistoryType()
    {
        return $this->container['historyType'];
    }

    /**
     * Sets historyType
     *
     * @param string|null $historyType describes the \"type\" of a history entry
     *
     * @return self
     */
    public function setHistoryType($historyType)
    {
        $allowedValues = $this->getHistoryTypeAllowableValues();
        if (!is_null($historyType) && !in_array($historyType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'historyType', must be one of '%s'",
                    $historyType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['historyType'] = $historyType;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


